#!/usr/bin/perl -w

my $usage 							= qq (
	blasthits4defline.pl -i infile -o outfile -E Evalue

	takes line data from a parsed BLAST file and formats it
	for sequence deflines.
);


# parse args
# open in and out files
# for each line
# 	split columns
#	if 1st row for query
#		if Eval set, does it meet threshold? if so...
#	write query, concatenated defline
# next

our ($infile, $outfile);
our $Eval							= 10;
parse_args();

open (my $INFILE, "<$infile")		|| die "Error opening file $infile for reading: $!\n";
open (my $OUTFILE, ">$outfile")		|| die "Error opening file $outfile for writing: $!\n";

my $counter							= 0;
while (my $line = <$INFILE>) {
	$counter++;
	chomp $line;
	next 							if $line =~ m/^#/;
	my @columns						= split(/\t/, $line);
	next 							if $columns[9] != 1;        # skip if not first hit in report
	#next							if $columns[4] > $Eval;
	print {$OUTFILE} 				$columns[1], "\t(";
	if ($columns[4] > $Eval) {
		print {$OUTFILE}			"*";
	}
	print {$OUTFILE}				$columns[3] . ": " . $columns[8] . " {E=", $columns[4], "})\n";
}

close $OUTFILE;
close $INFILE;

exit;

#
#
# END OF PROGRAM
#

sub parse_args {
	while (scalar(@ARGV)) {
		my $arg						= shift(@ARGV);
		if ($arg eq '-h') 			{print $usage;} 
		elsif ($arg eq '-i') 		{$infile = shift(@ARGV);}
		elsif ($arg eq '-o') 		{$outfile = shift(@ARGV);}
		elsif ($arg eq '-E')		{$Eval = shift(@ARGV);}
		else 						{ die "unknown argument '$arg'"; }
	}
	
	if (!defined $infile or !defined $outfile) {
	
		print "Error from undefined input arguments!\n";
		die $usage;
	}
}

